using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Windows.Forms;
using System.Xml;
using System.IO;


namespace NAVConnectorClient
{
    class NAVConnect
    {
        private TcpClient tc;
        private string host;
        private int port;

        public NAVConnect(string _host, int _port)
        {
            host = _host;
            port = _port;            
        }

        public bool TestConnect()
        {
            try
            {
                tc = new TcpClient(host, port);
                return true;
            }
            catch
            {
                return false;
            }
        }
        public bool TestConnect(out string _message)
        {
            try
            {
                tc = new TcpClient(host, port);
                _message = @"Ok";
                return true;
            }
            catch (Exception e)
            {
                _message = e.Message;
                return false;
            }
        }

        public bool Send(string _inmsg,out string _outmsg)
        {
            try
            {
                                
                tc = new TcpClient(host, port);
                NetworkStream ns = tc.GetStream();
                byte[] buf1 = Encoding.UTF8.GetBytes(_inmsg);
                ns.Write(buf1, 0, buf1.Length);                
                byte[] buf2 = new byte[tc.ReceiveBufferSize];
                int BytesRead = ns.Read(buf2, 0, tc.ReceiveBufferSize);
                _outmsg = Encoding.ASCII.GetString(buf2, 0, BytesRead);
                tc.Close();
                return true;
            }
            catch 
            {
                _outmsg = String.Empty;
                return false;
            }
        }

        public bool Command(string _name, out string _result)
        {
            string _xresult;

            // create a request...
            TextWriter w = new StringWriter();
            XmlTextWriter xmlWriterMsg = new XmlTextWriter(w);
            xmlWriterMsg.WriteStartDocument();
            xmlWriterMsg.WriteStartElement(@"command");
            xmlWriterMsg.WriteElementString(@"type", _name);
            xmlWriterMsg.WriteEndElement();
            xmlWriterMsg.WriteEndDocument();

            // send a request...
            bool SendResult = Send(w.ToString(), out _xresult);

            // receive a reply...
            _result = String.Empty;
            TextReader r = new StringReader(_xresult);
            XmlTextReader xmlReaderMsg = new XmlTextReader(r);
            xmlReaderMsg.WhitespaceHandling = WhitespaceHandling.None;            
            while (xmlReaderMsg.Read())
                if (xmlReaderMsg.NodeType == XmlNodeType.Element)
                    if (xmlReaderMsg.Name == @"result")
                        _result = xmlReaderMsg.GetAttribute(_name);
            xmlReaderMsg.Close();
            return SendResult;
        }
    }
}
